
module Foreign.GObject where

import Foreign.C.String.Generalised
import Control.Monad.Trans (MonadIO, liftIO)
import Foreign.C.Types (CULong)
import Foreign.C.String (CString)
import Foreign.Ptr (Ptr, FunPtr, nullPtr)

-- This is a nasty hack

foreign import ccall "static glib-object.h g_object_set"
    g_object_set_String
    :: Ptr a -> CString -> CString -> Ptr b -> IO ()
object_set_String :: (IsCString str1, IsCString str2, MonadIO io)
                  => Ptr a -> str1 -> str2 -> io ()
object_set_String o s1 s2 = liftIO $ do s1' <- toCString s1
                                        s2' <- toCString s2
                                        g_object_set_String o s1' s2' nullPtr
                                        finishedWithCString s2 s2'
                                        finishedWithCString s1 s1'

foreign import ccall "static glib-object.h g_signal_connect_data"
    c_g_signal_connect_data
    :: Ptr a -> CString -> FunPtr b -> Ptr c -> FunPtr d -> Int -> IO CULong
signal_connect_data :: (IsCString str, MonadIO io)
                    => Ptr a -> str -> FunPtr b -> Ptr c -> FunPtr d
                    -> Int -> io CULong
signal_connect_data inst sig fun dat destroy conn_flags
 = liftIO $ do sig' <- toCString sig
               r <- c_g_signal_connect_data inst sig' fun dat destroy conn_flags
               finishedWithCString sig sig'
               return r

foreign import ccall "static glib-object.h g_signal_handler_disconnect"
    c_g_signal_handler_disconnect
    :: Ptr a -> CULong -> IO ()
signal_handler_disconnect :: MonadIO io => Ptr a -> CULong -> io ()
signal_handler_disconnect inst h
 = liftIO $ c_g_signal_handler_disconnect inst h

